JUCE: AlertWindow Class Reference

JUCE

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
AlertWindow Class Reference

A window that displays a message and has buttons for the user to react to it. More...

Inheritance diagram for AlertWindow:

## Classes
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide alert-window drawing functionality. More...

## Public Types
enum | AlertIconType { NoIcon, QuestionIcon, WarningIcon, InfoIcon }
| The type of icon to show in the dialog box. More...
enum | ColourIds { backgroundColourId = 0x1001800, textColourId = 0x1001810, outlineColourId = 0x1001820 }
| A set of colour IDs to use to change the colour of various aspects of the alert box. More...
Public Types inherited from Component
enum | FocusChangeType { focusChangedByMouseClick, focusChangedByTabKey, focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...

## Public Member Functions
| AlertWindow (const String &title, const String &message, AlertIconType iconType, Component *associatedComponent=nullptr)
| Creates an AlertWindow. More...
| ~AlertWindow () override
| Destroys the AlertWindow. More...
AlertIconType | getAlertType () const noexcept
| Returns the type of alert icon that was specified when the window was created. More...
void | setMessage (const String &message)
| Changes the dialog box's message. More...
void | addButton (const String &name, int returnValue, const KeyPress &shortcutKey1=KeyPress(), const KeyPress &shortcutKey2=KeyPress())
| Adds a button to the window. More...
int | getNumButtons () const
| Returns the number of buttons that the window currently has. More...
void | triggerButtonClick (const String &buttonName)
| Invokes a click of one of the buttons. More...
void | setEscapeKeyCancels (bool shouldEscapeKeyCancel)
| If set to true and the window contains no buttons, then pressing the escape key will make the alert cancel its modal state. More...
void | addTextEditor (const String &name, const String &initialContents, const String &onScreenLabel=String(), bool isPasswordBox=false)
| Adds a textbox to the window for entering strings. More...
String | getTextEditorContents (const String &nameOfTextEditor) const
| Returns the contents of a named textbox. More...
TextEditor * | getTextEditor (const String &nameOfTextEditor) const
| Returns a pointer to a textbox that was added with addTextEditor(). More...
void | addComboBox (const String &name, const StringArray &items, const String &onScreenLabel=String())
| Adds a drop-down list of choices to the box. More...
ComboBox * | getComboBoxComponent (const String &nameOfList) const
| Returns a drop-down list that was added to the AlertWindow. More...
void | addTextBlock (const String &text)
| Adds a block of text. More...
void | addProgressBarComponent (double &progressValue)
| Adds a progress-bar to the window. More...
void | addCustomComponent (Component *component)
| Adds a user-defined component to the dialog box. More...
int | getNumCustomComponents () const
| Returns the number of custom components in the dialog box. More...
Component * | getCustomComponent (int index) const
| Returns one of the custom components in the dialog box. More...
Component * | removeCustomComponent (int index)
| Removes one of the custom components in the dialog box. More...
bool | containsAnyExtraComponents () const
| Returns true if the window contains any components other than just buttons. More...
Public Member Functions inherited from TopLevelWindow
| TopLevelWindow (const String &name, bool addToDesktop)
| Creates a TopLevelWindow. More...
| ~TopLevelWindow () override
| Destructor. More...
bool | isActiveWindow () const noexcept
| True if this is currently the TopLevelWindow that is actively being used. More...
void | centreAroundComponent (Component *componentToCentreAround, int width, int height)
| This will set the bounds of the window so that it's centred in front of another window. More...
void | setDropShadowEnabled (bool useShadow)
| Turns the drop-shadow on and off. More...
bool | isDropShadowEnabled () const noexcept
| True if drop-shadowing is enabled. More...
void | setUsingNativeTitleBar (bool useNativeTitleBar)
| Sets whether an OS-native title bar will be used, or a JUCE one. More...
bool | isUsingNativeTitleBar () const noexcept
| Returns true if the window is currently using an OS-native title bar. More...
void | addToDesktop ()
| Adds the window to the desktop using the default flags. More...
void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr) override
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
const String & | getName () const noexcept
| Returns the name of this component. More...
virtual void | setName (const String &newName)
| Sets the name of this component. More...
const String & | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop. More...
void | toFront (bool shouldAlsoGainFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component needs keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual KeyboardFocusTraverser * | createFocusTraverser ()
| Creates a KeyboardFocusTraverser object to use to determine the logic by which focus should be passed from this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the index used in determining the order in which focusable components should be traversed. More...
void | setFocusContainer (bool shouldBeFocusContainer) noexcept
| Indicates whether this component is a parent for components that can have their focus traversed. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparency level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released. More...
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component. More...
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus. More...
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | resized ()
| Called when this component's size has been changed. More...
virtual void | moved ()
| Called when this component's position has been changed. More...
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized. More...
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...

## Static Public Member Functions
static void JUCE_CALLTYPE | showMessageBox (AlertIconType iconType, const String &title, const String &message, const String &buttonText=String(), Component *associatedComponent=nullptr)
| Shows a dialog box that just has a message and a single button to get rid of it. More...
static void JUCE_CALLTYPE | showMessageBoxAsync (AlertIconType iconType, const String &title, const String &message, const String &buttonText=String(), Component *associatedComponent=nullptr, ModalComponentManager::Callback *callback=nullptr)
| Shows a dialog box that just has a message and a single button to get rid of it. More...
static bool JUCE_CALLTYPE | showOkCancelBox (AlertIconType iconType, const String &title, const String &message, const String &button1Text=String(), const String &button2Text=String(), Component *associatedComponent=nullptr, ModalComponentManager::Callback *callback=nullptr)
| Shows a dialog box with two buttons. More...
static int JUCE_CALLTYPE | showYesNoCancelBox (AlertIconType iconType, const String &title, const String &message, const String &button1Text=String(), const String &button2Text=String(), const String &button3Text=String(), Component *associatedComponent=nullptr, ModalComponentManager::Callback *callback=nullptr)
| Shows a dialog box with three buttons. More...
static bool JUCE_CALLTYPE | showNativeDialogBox (const String &title, const String &bodyText, bool isOkCancel)
| Shows an operating-system native dialog box. More...
Static Public Member Functions inherited from TopLevelWindow
static int | getNumTopLevelWindows () noexcept
| Returns the number of TopLevelWindow objects currently in use. More...
static TopLevelWindow * | getTopLevelWindow (int index) noexcept
| Returns one of the TopLevelWindow objects currently in use. More...
static TopLevelWindow * | getActiveTopLevelWindow () noexcept
| Returns the currently-active top level window. More...
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...

## Protected Member Functions
void | paint (Graphics &) override
void | mouseDown (const MouseEvent &) override
void | mouseDrag (const MouseEvent &) override
bool | keyPressed (const KeyPress &) override
void | lookAndFeelChanged () override
void | userTriedToCloseWindow () override
int | getDesktopWindowStyleFlags () const override
Protected Member Functions inherited from TopLevelWindow
virtual void | activeWindowStatusChanged ()
| This callback happens when this window becomes active or inactive. More...
void | focusOfChildComponentChanged (FocusChangeType) override
void | parentHierarchyChanged () override
void | recreateDesktopWindow ()
void | visibilityChanged () override

## Detailed Description

A window that displays a message and has buttons for the user to react to it.

For simple dialog boxes with just a couple of buttons on them, there are some static methods for running these.

For more complex dialogs, an AlertWindow can be created, then it can have some buttons and components added to it, and its runModalLoop() method is then used to show it. The value returned by runModalLoop() shows which button the user pressed to dismiss the box.

See also
  ThreadWithProgressWindow

## Member Enumeration Documentation

## ◆ AlertIconType

enum AlertWindow::AlertIconType

The type of icon to show in the dialog box.

Enumerator
NoIcon | No icon will be shown on the dialog box.
QuestionIcon | A question-mark icon, for dialog boxes that need the user to answer a question.
WarningIcon | An exclamation mark to indicate that the dialog is a warning about something and shouldn't be ignored.
InfoIcon | An icon that indicates that the dialog box is just giving the user some information, which doesn't require a response from them.

## ◆ ColourIds

enum AlertWindow::ColourIds

A set of colour IDs to use to change the colour of various aspects of the alert box.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The background colour for the window.
textColourId | The colour for the text.
outlineColourId | An optional colour to use to draw a border around the window.

## Constructor & Destructor Documentation

## ◆ AlertWindow()

AlertWindow::AlertWindow | ( | const String & | title,
|  | const String & | message,
|  | AlertIconType | iconType,
|  | Component * | associatedComponent = `nullptr`
| ) |  |

Creates an AlertWindow.

Parameters

  title | the headline to show at the top of the dialog box
  message | a longer, more descriptive message to show underneath the headline
  iconType | the type of icon to display
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.

## ◆ ~AlertWindow()

AlertWindow::~AlertWindow | ( |  | ) |
| override

Destroys the AlertWindow.

## Member Function Documentation

## ◆ getAlertType()

AlertIconType AlertWindow::getAlertType | ( |  | ) | const
| noexcept

Returns the type of alert icon that was specified when the window was created.

## ◆ setMessage()

void AlertWindow::setMessage | ( | const String & | message | ) |

Changes the dialog box's message.

This will also resize the window to fit the new message if required.

## ◆ addButton()

void AlertWindow::addButton | ( | const String & | name,
|  | int | returnValue,
|  | const KeyPress & | shortcutKey1 = `KeyPress()`,
|  | const KeyPress & | shortcutKey2 = `KeyPress()`
| ) |  |

Adds a button to the window.

Parameters

  name | the text to show on the button
  returnValue | the value that should be returned from runModalLoop() if this is the button that the user presses.
  shortcutKey1 | an optional key that can be pressed to trigger this button
  shortcutKey2 | a second optional key that can be pressed to trigger this button

## ◆ getNumButtons()

int AlertWindow::getNumButtons | ( |  | ) | const

Returns the number of buttons that the window currently has.

## ◆ triggerButtonClick()

void AlertWindow::triggerButtonClick | ( | const String & | buttonName | ) |

Invokes a click of one of the buttons.

## ◆ setEscapeKeyCancels()

void AlertWindow::setEscapeKeyCancels | ( | bool | shouldEscapeKeyCancel | ) |

If set to true and the window contains no buttons, then pressing the escape key will make the alert cancel its modal state.

By default this setting is true - turn it off if you don't want the box to respond to the escape key. Note that it is ignored if you have any buttons, and in that case you should give the buttons appropriate keypresses to trigger cancelling if you want to.

## ◆ addTextEditor()

void AlertWindow::addTextEditor | ( | const String & | name,
|  | const String & | initialContents,
|  | const String & | onScreenLabel = `String()`,
|  | bool | isPasswordBox = `false`
| ) |  |

Adds a textbox to the window for entering strings.

Parameters

  name | an internal name for the text-box. This is the name to pass to the getTextEditorContents() method to find out what the user typed-in.
  initialContents | a string to show in the text box when it's first shown
  onScreenLabel | if this is non-empty, it will be displayed next to the text-box to label it.
  isPasswordBox | if true, the text editor will display asterisks instead of the actual text

See also
  getTextEditorContents

## ◆ getTextEditorContents()

String AlertWindow::getTextEditorContents | ( | const String & | nameOfTextEditor | ) | const

Returns the contents of a named textbox.

After showing an AlertWindow that contains a text editor, this can be used to find out what the user has typed into it.

Parameters

  nameOfTextEditor | the name of the text box that you're interested in

See also
  addTextEditor

## ◆ getTextEditor()

TextEditor* AlertWindow::getTextEditor | ( | const String & | nameOfTextEditor | ) | const

Returns a pointer to a textbox that was added with addTextEditor().

## ◆ addComboBox()

void AlertWindow::addComboBox | ( | const String & | name,
|  | const StringArray & | items,
|  | const String & | onScreenLabel = `String()`
| ) |  |

Adds a drop-down list of choices to the box.

After the box has been shown, the getComboBoxComponent() method can be used to find out which item the user picked.

Parameters

  name | the label to use for the drop-down list
  items | the list of items to show in it
  onScreenLabel | if this is non-empty, it will be displayed next to the combo-box to label it.

See also
  getComboBoxComponent

## ◆ getComboBoxComponent()

ComboBox* AlertWindow::getComboBoxComponent | ( | const String & | nameOfList | ) | const

Returns a drop-down list that was added to the AlertWindow.

Parameters

  nameOfList | the name that was passed into the addComboBox() method when creating the drop-down

Returns
  the ComboBox component, or nullptr if none was found for the given name.

## ◆ addTextBlock()

void AlertWindow::addTextBlock | ( | const String & | text | ) |

Adds a block of text.

This is handy for adding a multi-line note next to a textbox or combo-box, to provide more details about what's going on.

## ◆ addProgressBarComponent()

void AlertWindow::addProgressBarComponent | ( | double & | progressValue | ) |

Adds a progress-bar to the window.

Parameters

  progressValue | a variable that will be repeatedly checked while the dialog box is visible, to see how far the process has got. The value should be in the range 0 to 1.0

## ◆ addCustomComponent()

void AlertWindow::addCustomComponent | ( | Component * | component | ) |

Adds a user-defined component to the dialog box.

Parameters

  component | the component to add - its size should be set up correctly before it is passed in. The caller is responsible for deleting the component later on - the AlertWindow won't delete it.

## ◆ getNumCustomComponents()

int AlertWindow::getNumCustomComponents | ( |  | ) | const

Returns the number of custom components in the dialog box.

See also
  getCustomComponent, addCustomComponent

## ◆ getCustomComponent()

Component* AlertWindow::getCustomComponent | ( | int | index | ) | const

Returns one of the custom components in the dialog box.

Parameters

  index | a value 0 to (getNumCustomComponents() - 1). Out-of-range indexes will return nullptr

See also
  getNumCustomComponents, addCustomComponent

## ◆ removeCustomComponent()

Component* AlertWindow::removeCustomComponent | ( | int | index | ) |

Removes one of the custom components in the dialog box.

Note that this won't delete it, it just removes the component from the window

Parameters

  index | a value 0 to (getNumCustomComponents() - 1). Out-of-range indexes will return nullptr

Returns
  the component that was removed (or null)

See also
  getNumCustomComponents, addCustomComponent

## ◆ containsAnyExtraComponents()

bool AlertWindow::containsAnyExtraComponents | ( |  | ) | const

Returns true if the window contains any components other than just buttons.

## ◆ showMessageBox()

static void JUCE_CALLTYPE AlertWindow::showMessageBox | ( | AlertIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | buttonText = `String()`,
|  | Component * | associatedComponent = `nullptr`
| ) |  |
| static

Shows a dialog box that just has a message and a single button to get rid of it.

The box is shown modally, and the method will block until the user has clicked the button (or pressed the escape or return keys).

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  buttonText | the text to show in the button - if this string is empty, the default string "OK" (or a localised version) will be used.
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.

## ◆ showMessageBoxAsync()

static void JUCE_CALLTYPE AlertWindow::showMessageBoxAsync | ( | AlertIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | buttonText = `String()`,
|  | Component * | associatedComponent = `nullptr`,
|  | ModalComponentManager::Callback * | callback = `nullptr`
| ) |  |
| static

Shows a dialog box that just has a message and a single button to get rid of it.

The box will be displayed and placed into a modal state, but this method will return immediately, and if a callback was supplied, it will be invoked later when the user dismisses the box.

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  buttonText | the text to show in the button - if this string is empty, the default string "OK" (or a localised version) will be used.
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.
  callback | if this is non-null, the callback will receive a call to its modalStateFinished() when the box is dismissed. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

Referenced by StandalonePluginHolder::askUserToLoadState(), and StandalonePluginHolder::askUserToSaveState().

## ◆ showOkCancelBox()

static bool JUCE_CALLTYPE AlertWindow::showOkCancelBox | ( | AlertIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | button1Text = `String()`,
|  | const String & | button2Text = `String()`,
|  | Component * | associatedComponent = `nullptr`,
|  | ModalComponentManager::Callback * | callback = `nullptr`
| ) |  |
| static

Shows a dialog box with two buttons.

Ideal for ok/cancel or yes/no choices. The return key can also be used to trigger the first button, and the escape key for the second button.

If the callback parameter is null, the box is shown modally, and the method will block until the user has clicked the button (or pressed the escape or return keys). If the callback parameter is non-null, the box will be displayed and placed into a modal state, but this method will return immediately, and the callback will be invoked later when the user dismisses the box.

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  button1Text | the text to show in the first button - if this string is empty, the default string "OK" (or a localised version of it) will be used.
  button2Text | the text to show in the second button - if this string is empty, the default string "cancel" (or a localised version of it) will be used.
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.
  callback | if this is non-null, the menu will be launched asynchronously, returning immediately, and the callback will receive a call to its modalStateFinished() when the box is dismissed, with its parameter being 1 if the ok button was pressed, or 0 for cancel. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

Returns
  true if button 1 was clicked, false if it was button 2. If the callback parameter is not null, the method always returns false, and the user's choice is delivered later by the callback.

## ◆ showYesNoCancelBox()

static int JUCE_CALLTYPE AlertWindow::showYesNoCancelBox | ( | AlertIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | button1Text = `String()`,
|  | const String & | button2Text = `String()`,
|  | const String & | button3Text = `String()`,
|  | Component * | associatedComponent = `nullptr`,
|  | ModalComponentManager::Callback * | callback = `nullptr`
| ) |  |
| static

Shows a dialog box with three buttons.

Ideal for yes/no/cancel boxes.

The escape key can be used to trigger the third button.

If the callback parameter is null, the box is shown modally, and the method will block until the user has clicked the button (or pressed the escape or return keys). If the callback parameter is non-null, the box will be displayed and placed into a modal state, but this method will return immediately, and the callback will be invoked later when the user dismisses the box.

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  button1Text | the text to show in the first button - if an empty string, then "yes" will be used (or a localised version of it)
  button2Text | the text to show in the first button - if an empty string, then "no" will be used (or a localised version of it)
  button3Text | the text to show in the first button - if an empty string, then "cancel" will be used (or a localised version of it)
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.
  callback | if this is non-null, the menu will be launched asynchronously, returning immediately, and the callback will receive a call to its modalStateFinished() when the box is dismissed, with its parameter being 1 if the "yes" button was pressed, 2 for the "no" button, or 0 if it was cancelled. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

Returns
  If the callback parameter has been set, this returns 0. Otherwise, it returns one of the following values:
  - 0 if the third button was pressed (normally used for 'cancel')
  - 1 if the first button was pressed (normally used for 'yes')
  - 2 if the middle button was pressed (normally used for 'no')

## ◆ showNativeDialogBox()

static bool JUCE_CALLTYPE AlertWindow::showNativeDialogBox | ( | const String & | title,
|  | const String & | bodyText,
|  | bool | isOkCancel
| ) |  |
| static

Shows an operating-system native dialog box.

Parameters

  title | the title to use at the top
  bodyText | the longer message to show
  isOkCancel | if true, this will show an ok/cancel box, if false, it'll show a box with just an ok button

Returns
  true if the ok button was pressed, false if they pressed cancel.

## ◆ paint()

void AlertWindow::paint | ( | Graphics & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ mouseDown()

void AlertWindow::mouseDown | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ mouseDrag()

void AlertWindow::mouseDrag | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ keyPressed()

bool AlertWindow::keyPressed | ( | const KeyPress & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ lookAndFeelChanged()

void AlertWindow::lookAndFeelChanged | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ userTriedToCloseWindow()

void AlertWindow::userTriedToCloseWindow | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ getDesktopWindowStyleFlags()

int AlertWindow::getDesktopWindowStyleFlags | ( |  | ) | const
| overrideprotectedvirtual

Reimplemented from TopLevelWindow.

The documentation for this class was generated from the following file:

- juce_AlertWindow.h